<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import type { User } from "$lib/types";
  import { postRaw } from "$lib/httpService";
  import { userStore, tokenStore } from "$lib/stores";
  import BaseModal from "./BaseModal.svelte";

  const dispatch = createEventDispatcher();
  let email = "";
  let password = "";

  async function login() {
    try {
      const response = await postRaw(
        "api/User/login",
        JSON.stringify({
          email,
          password,
        })
      );
      let auth;
      if (response.ok && (auth = response.headers.get("Authorization"))) {
        const data: User = await response.json();
        userStore.set(data);
        const authToken = auth.split(" ")[1];
        tokenStore.set(authToken);

        dispatch("close");
      } else {
        console.error("Login failed:", response);
        alert("Login failed: " + response.statusText);
      }
    } catch (error) {
      console.error("Login failed:", error);
    }
  }

  function closeModal() {
    dispatch("close");
  }
</script>

<BaseModal on:close={closeModal}>
  <h2>Login</h2>
  <input id="email" type="email" bind:value={email} placeholder="Email" />
  <input
    id="email"
    type="password"
    bind:value={password}
    placeholder="Password"
  />
  <div>
    <button on:click={login}>Login</button>
    <button on:click={closeModal}>Cancel</button>
  </div>
</BaseModal>
